import QtQuick 1.0

Item {
    id: animationsSetting
    width: 437
    height: 97

    property real valPos: slider.value

    property real maximum: 1000
    property real minimum: 100

    signal valueChanged(int value)


    Rectangle {
        id: rectangle1
        color: "#00000000"
        anchors.fill: parent

        Image {
            id: image1
            anchors.fill: parent
            source: "images/bg_setting_animation.png"
        }

        MouseArea {
            id: mouse_area1
            x: 0
            y: 32
            width: 437
            height: 34

            onClicked: {
                handle.x = mouse_area1.mouseX - (handle.width/2);
                slider.value = (maximum - minimum) * (handle.x-slider.xMin) / (slider.xMax - slider.xMin) + minimum;
                animationsSetting.valueChanged(slider.value);
            }
        }

        Rectangle {
            id: slider

            property int value

            onValueChanged: { handle.x = 2 + (value - minimum) * slider.xMax / (maximum - minimum); }
            property int xMax: slider.width - handle.width-2
            property int xMin: 2

            x: 0
            y: 37
            width: 437
            height: 25
            color: "#00000000"
            //anchors.fill: parent
            border.color: "white"; border.width: 0; radius: 8

            Rectangle {
                id: rectangle2
                x: 0
                y: 0
                width: x + handle.x + handle.width/2
                height: 25
                color: "#00000000"
                radius: 8
                //anchors.verticalCenter: parent.verticalCenter

                Rectangle {
                    id: image3
                    anchors.fill: parent
                    //source: "images/bar.png"
                    color: "#ffa600"
                    radius: 8
                }
            }
        }

        Rectangle {
            id: handle; smooth: true
            //x: 2 + (value - minimum) * slider.xMax / (maximum - minimum)

            x:  2 + (valPos - minimum) * slider.xMax / (maximum - minimum) //Math.floor((valPos * 0.0294)); //slider.width / 2 - handle.width / 2;
            y: 20; width: 46; height: 46; color: "#00000000"; radius: 6
            anchors.verticalCenter: parent.verticalCenter

            Image {
                id: image2
                anchors.fill: parent
                source: "images/slider_animation.png"
            }

            MouseArea {
                anchors.fill: parent
                drag.target: parent
                drag.axis: Drag.XAxis; drag.minimumX: slider.xMin; drag.maximumX: slider.xMax
                onPositionChanged: { slider.value = (maximum - minimum) * (handle.x-slider.xMin) / (slider.xMax - slider.xMin) + minimum;}
                onReleased: { animationsSetting.valueChanged(slider.value); }
            }

        }


    }



}
