import QtQuick 1.0

Item {
     id: container

     width: 480
     height: 825
     state: ""

     property string txtMessege: "Can't connect to server"

     signal accepted

     function show() {
         container.state = "show";
     }

     function close() {
         container.state = "";
     }

     function setMessage(msg) {
         txtMessage = msg;
     }

     // Use Fader component to dim the background & prevent key/touch events
     // to items lying underneath the dialog. I.e. makes the dialog "modal".
    Fader {
        id: fadeRect
        anchors.fill: parent

        // Bind main dialog's state with fader's corresponding states.
        state: container.state == "show" ? "faded" : ""
        transitionDuration: 300 // Use the same transition time as for the main dialog
    }

    Rectangle {
        id: dialog
        x: 90
        y: 282
        radius: 15
        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#7e7e7e"
            }

            GradientStop {
                position: 1
                color: "#595959"
            }
        }
        anchors.verticalCenter: parent .verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        border.width: 7
        opacity: 1
        border.color: "#1d1d1d"
        width: 300
        height: 158

        Rectangle {
            id: rectangle1
            x: 5
            y: 3
            width: 289
            height: 39
            color: "#818181"
            radius: 12
            border.width: 0
            border.color: "#3e2df5"

            Text {
                 id: text1
                 x: 0
                 y: 0
                 width: 300
                 height: 50
                 color: "#ececec"
                 text: "Error"
                 anchors.horizontalCenter: parent.horizontalCenter
                 anchors.verticalCenter: parent.verticalCenter
                 style: Text.Raised
                 styleColor: "#acacac"
                 font.bold: true
                 verticalAlignment: Text.AlignVCenter
                 horizontalAlignment: Text.AlignHCenter
                 font.pixelSize: 20
            }
        }

        Text {
            id: text2
            x: 10
            y: 17
            width: 290
            height: 110
            color: "#ececec"
            text: "Cannot connect to server"
            anchors.horizontalCenter: parent.horizontalCenter
            styleColor: "#acacac"
            style: Text.Raised
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            wrapMode: Text.WordWrap
            font.pixelSize: 21
        }

//        Image {
//            id: imgClose
//            x: 96
//            y: 100
//            width: 109
//            height: 40
//            source: "images/btn_close.png"

//            MouseArea {
//                id: mouse_area1
//                anchors.fill: parent

//                onPressed: {imgClose.state="press";}
//                onReleased: {imgClose.state=""; container.close();}

//            }
//            states: [
//                State {
//                    name: ""

//                    StateChangeScript { script: imgClose.source="images/btn_close.png"; }
//                },

//                State {
//                    name: "press"

//                    StateChangeScript { script: imgClose.source="images/btn_close_press.png"; }
//                }
//            ]
//        }

        Rectangle {
            id: rectangle2
            x: 96
            y: 100
            width: 109
            height: 40
            gradient: Gradient {
                GradientStop {
                    position: 0
                    color: "#ff9e25"
                }

                GradientStop {
                    position: 1
                    color: "#d95c01"
                }
            }

            Text {
                id: text3
                x: 36
                y: 13
                color: "#ececec"
                text: qsTr("CLOSE")
                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter
                font.pixelSize: 14
            }

            states: [
                State {
                    name: ""

                    StateChangeScript { script: rectangle2.gradient = gradient1; }
                },

                State {
                    name: "press"

                    StateChangeScript { script: rectangle2.gradient = gradient2; }
                }
            ]

            MouseArea {
                id: mouse_area1
                anchors.fill: parent

                onPressed: {rectangle2.state="press";}
                onReleased: {rectangle2.state=""; }
                onClicked: {container.close();}
            }
        }


        Gradient {
            id: gradient1

            GradientStop {
                position: 0
                color: "#ff9e25"
            }

            GradientStop {
                position: 1
                color: "#d95c01"
            }
        }

        Gradient {
            id: gradient2

            GradientStop {
                position: 0
                color: "#d95c01"
            }

            GradientStop {
                position: 1
                color: "#ff9e25"
            }
        }
    }

    states: [
        State {
            name: ""
            PropertyChanges {
                target: container
                opacity: 0
            }
        },
        State {
            name: "show"
            PropertyChanges {
                target: container
                opacity: 1
            }
        }
    ]

    transitions: [
        Transition {
            from: ""
            to: "show"
            SequentialAnimation {
                NumberAnimation { properties: "opacity"; easing.type: Easing.Linear; duration: 300 }
            }
        },
        Transition {
            from: "show"
            to: ""
            NumberAnimation { properties: "opactiy"; easing.type: Easing.Linear; duration: 300 }
        }
    ]
}
