import QtQuick 1.0
Item {
    id: container
    width: 100
    height: 50

    property string buttonName: "NOT SET"
    property string target: "NOT SET"

    property bool active: false
    property string bgImage: ""
    property string bgImagePressed: ""
    property string bgImageActive:  bgImagePressed

    signal clicked(string target, string button)

    Image {
        id: background
        anchors.fill: parent
        source: bgImage
        fillMode: Image.PreserveAspectFit
    }

    MouseArea {
        id: mouseArea
        anchors.fill: parent

        onClicked: {
            container.clicked(container.target, container.buttonName);
        }
    }

    states: [
        State {
            name: 'pressed'; when: mouseArea.pressed

            PropertyChanges { target: background; source: bgImagePressed; }
        },
        State {
            name: 'active'; when: container.active

            PropertyChanges { target: background; source: bgImageActive; }
        }
    ]
}
