import QtQuick 1.0
import "history.js" as HistoryJS
import "config.js" as ConfigJS

Rectangle {
    id: resultView
    width: 480
    height: 820

    property string mNetworkType
    property string mDate
    property string mDownload
    property string mUpload
    property string mPing

    property string sortName: "mDate"
    property string displayUnit: "kbps"
    property real speedFactor: 1

    Component.onCompleted: {
        tabbar1.selectedButton = "Result";
        ConfigJS.loadConfigures();
        HistoryJS.sortName = configuresModel.get(0).mSortName;
        console.log(HistoryJS.sortName);
        HistoryJS.loadHistory();
        speedtestEngine.displayUnits = configuresModel.get(0).mDisplayUnits;
        if (configuresModel.get(0).mDisplayUnits == 'kb/s')
            speedFactor = 8.0; //currentSpeed = speedBps/* + " bps\n"*/;
        else if (configuresModel.get(0).mDisplayUnits == 'kbps')
            speedFactor = 1.0; //currentSpeed = speedKbps/* + " kbps\n"*/;
        else
            speedFactor = 1024.0; //currentSpeed = speedMbps/* + " Mbps\n"*/;
    }

    Image {
        id: image1
        anchors.fill: parent
        source: "images/bg.png"

        TitleBar {
            id: titlebar1
            x: 0
            y: 12

            QuitButton {
                id: cpnQuitBtn
                x: 329
                y: 14
                anchors.right: parent.right
                anchors.rightMargin: 11
                anchors.verticalCenter: parent.verticalCenter
            }
        }

        Image {
            id: image3
            x: 0
            y: 70
            width: 480
            height: 126
            source: "images/head_result.png"
        }
    }

    Image {
        id: image2
        x: 0
        y: 210
        width: 480
        height: 476
        source: "images/bg_resultview.png"
    }

    TabBar {
        id: tabbar1
        x: 0
        y: 550
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0

        onTabButtonClicked: {
            console.log(targetState);
            //appWindow.state = targetState;
            switch (targetState) {
            case "SpeedtestView":
                {
                 pageStack.pop();
                //if (!speedtestEngine.isTested) {
                //    appWindow.pageStack.push(Qt.resolvedUrl("StartupView.qml"));
                //}
                //else {
                //    appWindow.pageStack.push(Qt.resolvedUrl("SpeedtestView.qml"));
                //}

                 break;
                }

            case "SettingView":
                {
                 //pageStack.pop();
                 pageStack.replace(Qt.resolvedUrl("SettingView.qml"));
                 break;
                }

            case "ResultView" :
                {
                 break;
                }

            case "AboutView":
                {
                 //pageStack.pop();
                 pageStack.replace(Qt.resolvedUrl("AboutView.qml"));
                 break;
                }

            default: break;
            }
        }
    }

    ListView {
        id: list_view1
        x: 0
        y: 252
        width: 480
        height: 423
        clip: true
        delegate: Component {
            ResultListItem {
                date: mDate
                downloadTime: (mDownloadTime/speedFactor).toFixed(2) + speedtestEngine.displayUnits
                uploadTime: (mUploadTime/speedFactor).toFixed(2) + speedtestEngine.displayUnits
                pingTime: mPingTime
            }
        }
        model: resultHistoryModel

        states: State {
            name: "ShowBars"
            when: list_view1.movingVertically
            PropertyChanges { target: verticalScrollBar; opacity: 1 }
        }

        transitions: Transition {
            NumberAnimation { properties: "opacity"; duration: 400 }
        }
    }

    ListModel {
        id: resultHistoryModel
/*
        ListElement {
            mNetworkType: "1"
            mDate: "1234"
            mDownloadTime: "987"
            mUploadTime: "890"
            mPingTime: "123456"
        }

        ListElement {
            mNetworkType: "1"
            mDate: "2345"
            mDownloadTime: "654"
            mUploadTime: "890"
            mPingTime: "123456"
        }

        ListElement {
            mNetworkType: "1"
            mDate: "3456"
            mDownloadTime: "321"
            mUploadTime: "890"
            mPingTime: "123456"
        }
*/
    }

    ListModel {
        id: configuresModel

       ListElement {
           mName: "conf"
           mDisplayUnits: "kbps"
           mSortName: "mDate"
           mAnimationSpeed: "1000"
       }
    }

    ScrollBarItem {
        id: verticalScrollBar
        x: 498
        y: 221
        width: 5; height: list_view1.height
        opacity: 0
        orientation: Qt.Vertical
        position: list_view1.visibleArea.yPosition
        anchors.right: parent.right
        anchors.rightMargin: 0
        pageSize: list_view1.visibleArea.heightRatio
        clip: true
    }

}
