import QtQuick 1.0
import "config.js" as ConfigJS
import "serverlist.js" as ServerListJS

Rectangle {
    id: settingView
    width: 480
    height: 820

    property string displayUnits: "kbps"
    property string sortName: "mDate"
    property string animationSpeed: "500"


    property string actionCmd: 'append'


    Component.onCompleted: {
        //ConfigJS.clearConfigures();
        //ConfigJS.saveConfigures();
        tabbar1.selectedButton = "Setting";
        ConfigJS.loadConfigures();
        displayspeed.selectedButton = configuresModel.get(0).mDisplayUnits;
        console.log(displayspeed.selectedButton)
        sorthistory.selectedButton = configuresModel.get(0).mSortName;
        animations.valPos = configuresModel.get(0).mAnimationSpeed * 1.0;
        displayUnits = configuresModel.get(0).mDisplayUnits;
        sortName = configuresModel.get(0).mSortName;
        animationSpeed = configuresModel.get(0).mAnimationSpeed;
        speedtestEngine.country = configuresModel.get(0).mCountry;
        speedtestEngine.url = configuresModel.get(0).mHostUrl;
        speedtestEngine.countryIndex = configuresModel.get(0).mCountryIndex;
        speedtestEngine.countryID = "" + configuresModel.get(0).mCountryID;

        if ((displayUnits == null) || (sortName == null) || (animationSpeed == null) || (speedtestEngine.country == null) || (speedtestEngine.url == null) ||
            (speedtestEngine.countryIndex == null) || (speedtestEngine.countryID == null)) {
            ConfigJS.clearConfigures();
            ConfigJS.saveConfigures();
            ConfigJS.loadConfigures();
            displayspeed.selectedButton = configuresModel.get(0).mDisplayUnits;
            console.log(displayspeed.selectedButton)
            sorthistory.selectedButton = configuresModel.get(0).mSortName;
            animations.valPos = configuresModel.get(0).mAnimationSpeed * 1.0;
            displayUnits = configuresModel.get(0).mDisplayUnits;
            sortName = configuresModel.get(0).mSortName;
            animationSpeed = configuresModel.get(0).mAnimationSpeed;
            speedtestEngine.country = configuresModel.get(0).mCountry;
            speedtestEngine.url = configuresModel.get(0).mHostUrl;
            speedtestEngine.countryIndex = configuresModel.get(0).mCountryIndex;
            speedtestEngine.countryID = "" + configuresModel.get(0).mCountryID;
        }
    }

    Image {
        id: image1
        anchors.fill: parent
        source: "images/bg.png"

        DisplaySpeedsSetting {
            id: displayspeed
            x: 21
            y: 203
            width: 441
            height: 100
            anchors.horizontalCenterOffset: 0
            anchors.horizontalCenter: parent.horizontalCenter

            onTabButtonClicked: {
                settingView.displayUnits = target;
                speedtestEngine.displayUnits = target;
                ConfigJS.displayUnits = settingView.displayUnits;
                ConfigJS.sortName = settingView.sortName;
                ConfigJS.animationSpeed = settingView.animationSpeed;
                ConfigJS.country = speedtestEngine.country;
                ConfigJS.hostUrl = speedtestEngine.url;
                ConfigJS.countryIndex = speedtestEngine.countryIndex;
                ConfigJS.countryID = speedtestEngine.countryID;
                ConfigJS.saveConfigures();
                ConfigJS.loadConfigures();
            }
        }

        SortHistorySetting {
            id: sorthistory
            x: 21
            y: 321
            width: 441
            height: 100
            anchors.horizontalCenter: parent.horizontalCenter

            onTabButtonClicked: {
                settingView.sortName = target;
                ConfigJS.displayUnits = settingView.displayUnits;
                ConfigJS.sortName = settingView.sortName;
                ConfigJS.animationSpeed = settingView.animationSpeed;
                ConfigJS.country = speedtestEngine.country;
                ConfigJS.hostUrl = speedtestEngine.url;
                ConfigJS.countryIndex = speedtestEngine.countryIndex;
                ConfigJS.countryID = speedtestEngine.countryID;
                ConfigJS.saveConfigures();
                ConfigJS.loadConfigures();
            }
        }

        AnimationsSetting {
            id: animations
            x: 23
            y: 441
            anchors.horizontalCenterOffset: 2
            anchors.horizontalCenter: parent.horizontalCenter

            onValueChanged: {
                console.log(value);
                settingView.animationSpeed = value;
                ConfigJS.displayUnits = settingView.displayUnits;
                ConfigJS.sortName = settingView.sortName;
                ConfigJS.animationSpeed = settingView.animationSpeed;
                ConfigJS.country = speedtestEngine.country;
                ConfigJS.hostUrl = speedtestEngine.url;
                ConfigJS.countryIndex = speedtestEngine.countryIndex;
                ConfigJS.countryID = speedtestEngine.countryID;
                ConfigJS.saveConfigures();
                ConfigJS.loadConfigures();
            }
        }

        Image {
            id: serverList
            x: 14
            y: 128
            width: 453
            height: 576
            opacity: 1
            visible: false
            z: 4
            source: "images/bg_selectserver.png"


            ListView {
                id: list_view1
                x: 5
                y: 119
                width: 443
                height: 452
                contentWidth: 0
                clip: true
                currentIndex: speedtestEngine.countryIndex
                delegate: Component {
                    ServerListItem {
                        countryName: country + " (" + name + ")"
                        serverUrl: url
                        countryID: id

                        onClicked: {
                            speedtestEngine.uploadUrl = hostUrl;
                            if (hostUrl.search(/upload.aspx/i) != -1) {
                                speedtestEngine.url = hostUrl.replace( /upload.aspx/i , "" );
                            }
                            else if (hostUrl.search(/upload.asp/i) != -1) {
                                speedtestEngine.url = hostUrl.replace( /upload.asp/i , "" );
                            }
                            if (hostUrl.search(/upload.php/i) != -1) {
                                speedtestEngine.url = hostUrl.replace( /upload.php/i , "" );
                            }
                            //speedtestEngine.url = hostUrl;
                            speedtestEngine.country = hostCountry;
                            speedtestEngine.countryID = hostCountryID;
                            speedtestEngine.countryIndex = index;
                            console.log(speedtestEngine.url);
                            ConfigJS.displayUnits = settingView.displayUnits;
                            ConfigJS.sortName = settingView.sortName;
                            ConfigJS.animationSpeed = settingView.animationSpeed;
                            ConfigJS.country = hostCountry;
                            ConfigJS.hostUrl = hostUrl;
                            ConfigJS.countryIndex = index
                            ConfigJS.countryID = hostCountryID;
                            ConfigJS.saveConfigures();
                            ConfigJS.loadConfigures();
                        }

                        onHilighted: {
//                            console.debug(index);
                            speedtestEngine.countryIndex = index;
                        }

                        Behavior on focus {
                            SequentialAnimation {
                                NumberAnimation { target: serverList; property: "opacity"; to: 0; duration: 500 }
                                PropertyAction { target: serverList; property: "visible"; value: "false" }
                            }
                        }
                    }

                }
                model: xmlServerList

                states: State {
                    name: "ShowBars"
                    when: list_view1.movingVertically
                    PropertyChanges { target: verticalScrollBar; opacity: 1 }
                }

                transitions: Transition {
                    NumberAnimation { properties: "opacity"; duration: 400 }
                }

                Loading {
                    id: loading1
                    x: 206
                    y: 279
                    anchors.verticalCenterOffset: -20
                    anchors.horizontalCenter: parent.horizontalCenter
                    anchors.verticalCenter: parent.verticalCenter
                    visible: speedtestEngine.loadingServerList

                }
             }

            ScrollBarItem {
                id: verticalScrollBar
                x: 498
                y: 119
                width: 5; height: list_view1.height
                opacity: 0
                orientation: Qt.Vertical
                position: list_view1.visibleArea.yPosition
                anchors.right: parent.right
                anchors.rightMargin: 0
                pageSize: list_view1.visibleArea.heightRatio
                clip: true
            }

        }

    }


    TitleBar {
        id: titlebar1
        x: 0
        y: 12

        QuitButton {
            id: cpnQuitBtn
            x: 329
            y: 14
            anchors.right: parent.right
            anchors.rightMargin: 11
            anchors.verticalCenter: parent.verticalCenter
        }
    }

    Image {
        id: image2
        x: 0
        y: 70
        width: 480
        height: 123
        source: "images/head_selectedserver.png"

        MouseArea {
            id: mouse_area1
            x: 97
            y: 45
            width: 286
            height: 61
            anchors.horizontalCenterOffset: 0
            anchors.horizontalCenter: parent.horizontalCenter

            onClicked: {
                if (serverList.visible == false) {
                    list_view1.positionViewAtIndex(speedtestEngine.countryIndex, ListView.Beginning);       // Indexed Item at Top of list
                    serverList.opacity = 1;
                    serverList.visible = true;

                }
                else {
                    serverList.visible = false;
                }
            }
        }

        Text {
            id: txtCountry
            x: 107
            y: 9
            color: "#f0f0f0"
            text: speedtestEngine.country
            anchors.horizontalCenter: parent.horizontalCenter
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            font.bold: true
            font.pixelSize: 25
        }


    }


    TabBar {
        id: tabbar1
        x: 0
        y: 550
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0

        onTabButtonClicked: {
            console.log(targetState);
            //appWindow.state = targetState;
            switch (targetState) {
            case "SpeedtestView":
                {
                pageStack.pop();
                }

            case "SettingView":
                {
                 break;
                }

            case "ResultView" :
                {
                 //pageStack.pop();
                 pageStack.replace(Qt.resolvedUrl("ResultView.qml"));
                 break;
                }

            case "AboutView":
                {
                 //pageStack.pop();
                 pageStack.replace(Qt.resolvedUrl("AboutView.qml"));
                 break;
                }

            default: break;
            }
        }
    }

    ListModel {
        id: configuresModel

        ListElement {
            mName: "conf"
            mDisplayUnits: "kbps"
            mSortName: "mDate"
            mAnimationSpeed: "1000"
        }
    }

    ListModel { id: blankListModel }



}
