import QtQuick 1.0

Rectangle {
    id: startupView
    width: 480
    height: 820

    property string activedButton: "Speedtest"

    Component.onCompleted: {tabbar1.selectedButton = "Speedtest"; console.log("page:" + appWindow.pageStack.currentPage)}

    onVisibleChanged: { tabbar1.selectedButton = "Speedtest"; }

    Image {
        id: image1
        x: 0
        y: 0
        anchors.rightMargin: 0
        anchors.bottomMargin: 0
        anchors.leftMargin: 0
        anchors.topMargin: 0
        anchors.fill: parent
        source: "images/bg.png"

        TabBar {
            id: tabbar1
            x: 0
            y: 550
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 0
            selectedButton: activedButton

            onTabButtonClicked: {
                console.log(targetState);
                //appWindow.state = targetState;
                switch (targetState) {
                case "SpeedtestView":
                    {
                     break;
                    }

                case "SettingView":
                    {
                     pageStack.pop();
                     pageStack.push(Qt.resolvedUrl("SettingView.qml"));
                     break;
                    }

                case "ResultView" :
                    {
                     pageStack.pop();
                     pageStack.push(Qt.resolvedUrl("ResultView.qml"));
                     break;
                    }

                case "AboutView":
                    {
                     pageStack.pop();
                     pageStack.push(Qt.resolvedUrl("AboutView.qml"));
                     break;
                    }

                default: break;
                }
            }
        }

        QuitButton {
            id: quitbutton1
            x: 449
            y: 14
            anchors.right: parent.right
            anchors.rightMargin: 11
        }
    }

    TitleBar {
        id: titlebar1
        x: 0
        y: 105
        width: 480
        height: 50
        anchors.horizontalCenter: parent.horizontalCenter

        Image {
            id: image2
            x: 58
            y: 55
            width: 365
            height: 16
            anchors.horizontalCenter: parent.horizontalCenter
            source: "images/subtitle.png"
        }
    }

    Image {
        id: image3
        x: 0
        y: 212
        width: 480
        height: 271
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        source: "images/btn_begintest.png"

        MouseArea {
            width: 480
            height: 271
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter

            onPressed: { image3.source = "images/btn_begintest_press.png" }
            onClicked: {
                image3.source = "images/btn_begintest_press.png"
                appWindow.pageStack.clear();
                appWindow.pageStack.push(Qt.resolvedUrl("SpeedtestView.qml"));
            }
        }
    }


}
