import QtQuick 1.0

Item {
    id: container
    width: 480
    height: 150

    property string selectedButton: btnSpeedtest.buttonName

    signal tabButtonClicked(string targetState, string buttonName);
    Image {
        id: imgBackground
        x: 5
        y: 0
        width: 466
        height: 86
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        source: "images/bg_tabbar.png"

        ImageButtonItem {
            id: btnAbout
            x: 373
            y: 15
            width: 57
            height: 95
            buttonName: "About"
            target: "AboutView"
            bgImage : "images/btn_about.png"
            bgImagePressed: "images/btn_about_press.png"
            bgImageActive: "images/btn_about_press.png"
            active: container.selectedButton === buttonName

            onClicked: {
                container.selectedButton = buttonName;
                container.tabButtonClicked(target, buttonName);
            }
        }

        ImageButtonItem {
            id: btnResult
            x: 261
            y: 16
            width: 68
            height: 95
            buttonName: "Result"
            target: "ResultView"
            bgImage: "images/btn_result.png"
            bgImagePressed: "images/btn_result_press.png"
            bgImageActive: "images/btn_result_press.png"
            active: container.selectedButton === buttonName

            onClicked: {
                container.selectedButton = buttonName;
                container.tabButtonClicked(target, buttonName);
            }
        }

        ImageButtonItem {
            id: btnSetting
            x: 142
            y: 16
            width: 67
            height: 94
            buttonName: "Setting"
            target: "SettingView"
            bgImage: "images/btn_setting.png"
            bgImagePressed: "images/btn_setting_press.png"
            bgImageActive: "images/btn_setting_press.png"
            active: container.selectedButton === buttonName

            onClicked: {
                container.selectedButton = buttonName;
                container.tabButtonClicked(target, buttonName);
            }
        }

        ImageButtonItem {
            id: btnSpeedtest
            x: 12
            y: 15
            width: 93
            height: 95
            buttonName: "Speedtest"
            target: "SpeedtestView"
            bgImage: "images/btn_speedtest.png"
            bgImagePressed: "images/btn_speedtest_press.png"
            bgImageActive: "images/btn_speedtest_press.png"
            active: container.selectedButton === buttonName

            onClicked: {
                container.selectedButton = buttonName;
                container.tabButtonClicked(target, buttonName);
            }

        }
    }

}
