import QtQuick 1.0
import com.nokia.meego 1.0
import "serverlist.js" as ServerListJS

PageStackWindow {
    id: appWindow

    initialPage: mainPage


    MainPage {
        id: mainPage

//        anchors { left: parent.left; right: parent.right; }
    }

    SpeedtestEngine {
        id: speedtestEngine
    }

//    Component.onCompleted: {
//        appWindow.pageStack.push(Qt.resolvedUrl("MainPage.qml"));
//        console.log("page:" + appWindow.pageStack.currentPage)
//    }


    ListModel {
        id: downloadSpeedList
    }

    ListModel {
        id: uploadSpeedList
    }

    XmlListModel {
        id: xmlServerList
        //source: "http://www.speedtest.net/speedtest-servers.php"
        source: "server2.xml"
        query: "/settings/servers/server"

        XmlRole { name: "url"; query: "@url/string()" }
        XmlRole { name: "name"; query: "@name/string()" }
        XmlRole { name: "country"; query: "@country/string()" }
        XmlRole { name: "lat"; query: "@lat/string()" }
        XmlRole { name: "lon"; query: "@lon/string()" }
        XmlRole { name: "id"; query: "@id/string()" }

        onStatusChanged: {
            if (status == XmlListModel.Ready) {
                console.log("status: ready");
                speedtestEngine.loadingServerList = false;
            }
            else if (status == XmlListModel.Error) {
                console.log("status: error");
            }
            else if (status == XmlListModel.Loading) {
                console.log("status: loading");
                speedtestEngine.loadingServerList = true;
            }
        }

    }

    ListModel { id: serverListModel }
}

